"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTypedCollection = void 0;
const react_1 = require("react");
const reactfire_1 = require("reactfire");
const useSnapData_js_1 = require("./useSnapData.js");
const utils_js_1 = require("./utils.js");
const useTypedCollection = (typedRef, selector, dataOptions = {}) => {
    var _a;
    const _typedQuery = (_a = selector === null || selector === void 0 ? void 0 : selector(typedRef.select)) !== null && _a !== void 0 ? _a : typedRef;
    const { safeRef: safeQuery, refChanged } = (0, utils_js_1.useSafeRef)(_typedQuery.raw);
    const memoizedTypedRef = (0, react_1.useRef)();
    if (refChanged) {
        memoizedTypedRef.current = typedRef;
    }
    const status = (0, reactfire_1.useFirestoreCollection)(safeQuery, { suspense: true });
    (0, utils_js_1.useFirestoreErrorLogger)(status.error);
    const { snap, data } = (0, useSnapData_js_1.useQuerySnapData)(typedRef, status.data, dataOptions);
    return (0, react_1.useMemo)(() => {
        refChanged;
        return { ...status, typedRef: memoizedTypedRef.current, snap, data };
    }, [data, refChanged, snap, status]);
};
exports.useTypedCollection = useTypedCollection;
