import { ObservableStatus } from 'reactfire';
import { Except } from 'type-fest';
import { DocumentSnapDataOptions, STypes, TypedDocumentRef, TypedDocumentSnap } from '../core/index.js';
import { _web } from '../lib/firestore-types.js';
export declare type UseTypedDoc<S extends STypes.RootOptions.All, L extends string, U = STypes.DocDataAt<S, _web.Firestore, L>, V = U> = {
    typedRef: TypedDocumentRef<S, _web.Firestore, L, U>;
    snap: TypedDocumentSnap<S, _web.Firestore, L, U>;
    data: V | undefined;
} & Except<ObservableStatus<unknown>, 'data'>;
export declare const useTypedDoc: <S extends STypes.RootOptions.All, L extends string, U, V = U>(typedRef: TypedDocumentRef<S, _web.Firestore, L, U>, dataOptions?: DocumentSnapDataOptions<S, _web.Firestore, L, U, V>) => UseTypedDoc<S, L, U, V>;
export declare const useTypedDocOnce: <S extends STypes.RootOptions.All, L extends string, U, V = U>(typedRef: TypedDocumentRef<S, _web.Firestore, L, U>, dataOptions?: DocumentSnapDataOptions<S, _web.Firestore, L, U, V>) => UseTypedDoc<S, L, U, V>;
