"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTypedDocOnce = exports.useTypedDoc = void 0;
const react_1 = require("react");
const reactfire_1 = require("reactfire");
const useSnapData_js_1 = require("./useSnapData.js");
const utils_js_1 = require("./utils.js");
const createUseTypedDocHook = (hook) => {
    return (typedRef, dataOptions = {}) => {
        const { safeRef, refChanged } = (0, utils_js_1.useSafeRef)(typedRef.raw);
        const memoizedTypedRef = (0, react_1.useRef)();
        if (refChanged) {
            memoizedTypedRef.current = typedRef;
        }
        const status = hook(safeRef, { suspense: true });
        (0, utils_js_1.useFirestoreErrorLogger)(status.error);
        const { snap, data } = (0, useSnapData_js_1.useDocumentSnapData)(typedRef, status.data, dataOptions);
        return (0, react_1.useMemo)(() => {
            refChanged;
            return { ...status, typedRef: memoizedTypedRef.current, snap, data };
        }, [data, refChanged, snap, status]);
    };
};
exports.useTypedDoc = createUseTypedDocHook(reactfire_1.useFirestoreDoc);
exports.useTypedDocOnce = createUseTypedDocHook(reactfire_1.useFirestoreDocOnce);
