import * as functions from 'firebase-functions';
import { z } from 'zod';
/**
 * functions/index.ts file
 */
export declare const UserJsonType: z.ZodObject<z.extendShape<{
    name: z.ZodString;
    displayName: z.ZodUnion<[z.ZodString, z.ZodNull]>;
    age: z.ZodNumber;
    timestamp: import("../index.js").ZodTimestamp;
    options: z.ZodOptional<z.ZodObject<{
        a: z.ZodBoolean;
    }, "strip", z.ZodTypeAny, {
        a: boolean;
    }, {
        a: boolean;
    }>>;
}, {
    timestamp: z.ZodString;
}>, "strip", z.ZodTypeAny, {
    options?: {
        a: boolean;
    } | undefined;
    name: string;
    displayName: string | null;
    age: number;
    timestamp: string;
}, {
    options?: {
        a: boolean;
    } | undefined;
    name: string;
    displayName: string | null;
    age: number;
    timestamp: string;
}>;
export declare const callable: {
    createUser: functions.TriggerAnnotated & ((req: functions.Request<import("express-serve-static-core").ParamsDictionary, any, any, import("qs").ParsedQs, Record<string, any>>, resp: functions.Response<any, Record<string, any>>) => void | Promise<void>) & functions.Runnable<any> & import("../index.js").FunTypes.Callable.Meta<z.ZodObject<z.extendShape<{
        name: z.ZodString;
        displayName: z.ZodUnion<[z.ZodString, z.ZodNull]>;
        age: z.ZodNumber;
        timestamp: import("../index.js").ZodTimestamp;
        options: z.ZodOptional<z.ZodObject<{
            a: z.ZodBoolean;
        }, "strip", z.ZodTypeAny, {
            a: boolean;
        }, {
            a: boolean;
        }>>;
    }, {
        timestamp: z.ZodString;
    }>, "strip", z.ZodTypeAny, {
        options?: {
            a: boolean;
        } | undefined;
        name: string;
        displayName: string | null;
        age: number;
        timestamp: string;
    }, {
        options?: {
            a: boolean;
        } | undefined;
        name: string;
        displayName: string | null;
        age: number;
        timestamp: string;
    }>, z.ZodObject<{
        result: z.ZodBoolean;
    }, "strip", z.ZodTypeAny, {
        result: boolean;
    }, {
        result: boolean;
    }>>;
};
export declare const firestoreTrigger: {
    onUserCreate: functions.CloudFunction<FirebaseFirestore.QueryDocumentSnapshot<FirebaseFirestore.DocumentData>>;
};
export declare const http: {
    getKeys: functions.HttpsFunction;
};
export declare const topic: {
    publishMessage: functions.Runnable<functions.pubsub.Message> & functions.TriggerAnnotated & ((input: any, context?: any) => any) & import("../index.js").FunTypes.Topic.Meta<"publish_message", z.ZodObject<{
        text: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        text: string;
    }, {
        text: string;
    }>>;
};
export declare const schedule: {
    cron: functions.CloudFunction<unknown>;
};
