import { ObservableStatus } from 'reactfire';
import { Except } from 'type-fest';
import { QueryDocumentSnapDataOptions, STypes, TypedCollectionRef, TypedQueryRef, TypedQuerySnap } from '../core/index.js';
import { _web } from '../lib/firestore-types.js';
export declare type UseTypedQuery<S extends STypes.RootOptions.All, L extends string, U = STypes.DocDataAt<S, _web.Firestore, L>, V = U> = {
    typedRef: TypedCollectionRef<S, _web.Firestore, L, U>;
    snap: TypedQuerySnap<S, _web.Firestore, L, U>;
    data: V[];
} & Except<ObservableStatus<unknown>, 'data'>;
export declare const useTypedCollection: <S extends STypes.RootOptions.All, L extends string, U, V = U>(typedRef: TypedCollectionRef<S, _web.Firestore, L, U>, selector?: ((select: STypes.MappedSelectors<S, _web.Firestore, L, U, ReturnType<STypes.EnsureOptions<import("../core/types/_object.js").ParseLocString<L>[0] extends string ? {
    0: { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S];
    1: (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0] extends string ? {
        0: { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]];
        1: ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0] extends string ? {
            0: { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]];
            1: (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0] extends string ? {
                0: { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]];
                1: ((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0] extends string ? {
                    0: { [K_4 in keyof { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]]: K_4 extends `/${((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]][K_4] : never; }[keyof { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]];
                    1: (((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0] extends string ? {
                        0: { [K_5 in keyof { [K_4 in keyof { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]]: K_4 extends `/${((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]][K_4] : never; }[keyof { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]]]: K_5 extends `/${(((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_4 in keyof { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]]: K_4 extends `/${((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]][K_4] : never; }[keyof { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]][K_5] : never; }[keyof { [K_4 in keyof { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]]: K_4 extends `/${((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]][K_4] : never; }[keyof { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]]];
                        1: never;
                    }[(((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[1] extends undefined ? 0 : 1] : (((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends [] ? { [K_4 in keyof { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]]: K_4 extends `/${((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]][K_4] : never; }[keyof { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]] : never;
                }[((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[1] extends undefined ? 0 : 1] : ((((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends [] ? { [K_3 in keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]]: K_3 extends `/${(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]][K_3] : never; }[keyof { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]] : never;
            }[(((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[1] extends undefined ? 0 : 1] : (((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends [] ? { [K_2 in keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]]: K_2 extends `/${((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]][K_2] : never; }[keyof { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]] : never;
        }[((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never)[1] extends undefined ? 0 : 1] : ((import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends [] ? { [K_1 in keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]]: K_1 extends `/${(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[0]}/{${string}}` ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S][K_1] : never; }[keyof { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S]] : never;
    }[(import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never)[1] extends undefined ? 0 : 1] : (import("../core/types/_object.js").ParseLocString<L> extends readonly [string, ...string[]] ? (...args: readonly [string, ...string[]] & import("../core/types/_object.js").ParseLocString<L>) => void extends (top: any, ...args: infer T) => void ? T : never : never) extends [] ? { [K in keyof S]: K extends `/${import("../core/types/_object.js").ParseLocString<L>[0]}/{${string}}` ? S[K] : never; }[keyof S] : never;
}[import("../core/types/_object.js").ParseLocString<L>[1] extends undefined ? 0 : 1] : import("../core/types/_object.js").ParseLocString<L> extends [] ? S : never>["model"]["selectors"]>>) => TypedQueryRef<S, _web.Firestore, L, U>) | undefined, dataOptions?: QueryDocumentSnapDataOptions<S, _web.Firestore, L, U, V>) => UseTypedQuery<S, L, U, V>;
